library(tm)

totale <- VCorpus(DirSource(directory = "/Users/valentinaporcu/R_test/obama", encoding = "UTF-8"))

# eliminiamo gli spazi bianchi
totale2 <- tm_map(totale, stripWhitespace)

# trasformiamo il testo in lettere minuscole
totale3 <- tm_map(totale2, content_transformer(tolower))

# eliminiamo le stopwords
totale4 <- tm_map(totale3, removeWords, stopwords("english"))

# effettuiamo lo stemming, riducendo le parole alla propria radice
totale5 <- tm_map(totale4, stemDocument)



# funzione
clean <- function(text){
        corpus <- tm_map(text, removePunctuation)
        corpus <- tm_map(text, stripWhitespace)
        corpus <- tm_map(text, removeNumbers)
        corpus <- tm_map(text, content_transformer(tolower))
        corpus <- tm_map(text, removeWords, stopwords("en"))
        return(text)
}


# creiamo la DTM
matrice.doc <- DocumentTermMatrix(totale5)


findFreqTerms(matrice.doc, 10)

findAssocs(matrice.doc, "gun", 0.8)

inspect(removeSparseTerms(matrice.doc, 0.8))

test2 <- (removeSparseTerms(matrice.doc, 0.8))
