# connessione a Twitter
api_key <-  "XXXXXXXXXXXXXXXXXX"
api_secret <- "XXXXXXXXXXXXXXXXXX"
access_token <- "XXXXXXXXXXXXXXXXXX"
access_secret <- "XXXXXXXXXXXXXXXXXX"

# caricamento del pacchetto twitteR
library(twitteR)
library(tm)

setup_twitter_oauth(api_key, api_secret, access_token, access_secret)

# interrogazione del database di Twitter ed estrazione di 2.000 tweets
bd1 <- searchTwitter("#apple", n=2000, lang="en")

# estraiamo il testo dei tweets
bd2 <- sapply(bd1, function(x) x$getText())

# convertiamo in corpus, in modo da poterlo trattare con tm 
bdc <- Corpus(VectorSource(bd2))

# ripuliamo il testo
bdc <- tm_map(bdc, content_transformer(function(x) iconv(x, to='UTF-8-MAC', sub='byte')), mc.cores=1)

bdc <- tm_map(bdc, content_transformer(tolower)) 
bdc <- tm_map(bdc, removePunctuation)
bdc <- tm_map(bdc, function(x)removeWords(x,stopwords()))

# creiamo la matrice documenti termini
dtm <- DocumentTermMatrix(bdc)

dtm <- removeSparseTerms(dtm, sparse = 0.95)
mat2 <- as.matrix(dtm)

k <- 6
kmeans_res <- kmeans(mat2, k)
round(kmeans_res$centers, digits=3)



for (i in 1:k) {
        cat(paste("cluster", i, ":  ", sep=""))
        s <- sort(kmeans_res$centers[i,], decreasing=T)
        cat(names(s)[1:3], "\n")
}


######### Medoidi
library(fpc)

med <- pamk(mat2, metric="manhattan")

k <- med$nc

med <- med$pamobject


for (i in 1:k) {
        cat(paste("cluster", i, ":  "))
        cat(colnames(med$medoids)[which(med$medoids[i,]==1)], "\n")
}



plot(med, color=F, labels=4, lines=0, cex=.8, col.clus=1, col.p=med$clustering)
