# funzioni per le stringhe - la famiglia grep*

# grep()

grep.esempio1 <- c("Firenze", "Roma", "Dubai", 
                   "mele", "pesche", "arselle", "mitili", 
                   "01/02/1971", 
                   "gatto", "cane", "topo", 
                   "Genova", "Rimini", "Riccione", "Rospo")

grep(pattern = "F", grep.esempio1)

grep(pattern = "c", grep.esempio1)

grep(pattern = "r", grep.esempio1)

grep(pattern = "r", grep.esempio1, ignore.case=TRUE)

grep(pattern = "Firenze", grep.esempio1)

grep(pattern = "Roma", grep.esempio1)

grep(pattern = "^m", grep.esempio1)

grep(pattern = "^m", grep.esempio1, value = TRUE)


# grepl()

grepl(pattern = "F", grep.esempio1)

# gsub()

gsub(pattern = "a", "b", grep.esempio1)

gsub(pattern = "Roma", "Milano", grep.esempio1)

grep.esempio1

grep.esempio2 <- gsub(pattern = "Roma", "Milano", grep.esempio1)

# regexpr()

regexpr(pattern = "F", grep.esempio1)

# gregexpr()

gregexpr(pattern = "F", grep.esempio1)

# strsplit()

div.stringa.1 <- c("abc.def")

strsplit(div.stringa.1, split = "\\.")

div.stringa.2 <- c("test1;test2")
strsplit(div.stringa.2, split = "\\;")

# match()

es.1 <- c("A", "B", "C", "D")
es.2 <- c("A", "b", "c", "d")

# confrontiamo i due oggetti con la funzione match()
match(x = es.1, table = es.2)

# creiamo altri due oggetti, stavolta uguali:
        
es.3 <- c("A", "B", "C", "D")
es.4 <- c("A", "B", "C", "D")
match(x = es.3, table = es.4)
regexpr(pattern = "F", grep.esempio1)

# substr()

substr("abcdefg", 2, 6)

# paste()

paste(c("io", "tu"), "e lui")

paste(c("io", "tu"), "e lui", collapse = "")

paste("Today is", date())

paste("x", 1:5, sep =  )

paste("x", 1:5, sep = "%")

id <- paste0("id", 1:10)
id

# gsub()

ph <- c("Let's do a test to see how to use the gsub fonction in R, and how also the sub fonction works")

gsub("do a", "do a couple of", ph)

gsub("how", "HOW", ph)

sub("how", "HOW", ph)

mail <- c("my mail is test@test.com", "my other test email ist test2@test.co.uk")

sub("(.*\\s+|^)(\\S+@\\S+).*", "\\2", mail)

unlist(regmatches(mail, gregexpr("\\S+@\\S+", mail)))

num <- c("Alex visited 5 cities and 8 beaches this year", "Alex spent 10 days of his summer holidays visiting Italy")

# con la notazione seguente, eliminiamo i numeri da un testo
gsub("\\d", "", num)

# o in alternativa
gsub("[[:digit:]]", "", num)

# con la notazione che segue, invece, estraiamo solo i numeri
gsub("\\D", "", num)

gsub("[[:punct:]]", "", ph)

ts <- "test    with    some    more    spaces"
gsub("[ \t]{2,}", " ", ts)


gsub("(RT|via)((?:\\b\\W*@\\w+)+)","", corpus_tweet)

gsub("http[^[:blank:]]+", "", corpus_tweet)

df <- data.frame(name = c("Laura", "Simon", "Katherine", "Francis", "Joseph", "Rosie"), 
                 heights = c("163cm", "180cm", "165cm", "169cm", "178cm", "164cm"),
                 sex = c("f", "m", "f", "m", "m", "f"))

# sovrascriviamo la variabile heights con una nuova e usando la funzione gsub() sostituiamo “cm” con nulla (identificato dalle virgolette vuote “”) ome terzo argomento mettiamo la variabile originale
df$heights <- gsub("cm", "", df$heights)

# stampiamo il dataframe corretto
df



df2 <- data.frame(name = c("Laura", "Simon", "Katherine", "Francis", "Joseph", "Rosie"), 
                  heights = c("163;cm", "180;cm", "165;cm", "169;cm", "178;cm", "164;cm"), 
                  sex = c("f", "m", "f", "m", "m", "f"))

df2$heights <- gsub(";", ",", df2$heights)
df2